"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PersonsClient = void 0;
const genericClient_1 = require("./genericClient");
class PersonsClient {
    constructor(basePath, auth) {
        this.client = new genericClient_1.GenericClient({
            basePath: basePath,
            endpointPath: "/v2/persons",
            auth: auth,
            writeTypeName: "PersonWrite",
            singleResponseTypeName: "WrappedPerson",
            multipleResponseTypeName: "WrappedWithMetaArrayPerson",
            patchTypeName: "PersonWritePatch",
        });
    }
    create(person) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.client.create(person);
        });
    }
    remove(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.client.remove(id);
        });
    }
    get(id, query = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.client.get(id, query);
        });
    }
    find(findParams = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.client.find(findParams);
        });
    }
    patch(id, person) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.client.patch(id, person);
        });
    }
}
exports.PersonsClient = PersonsClient;
