/// <reference types="node" />
/// <reference types="node" />
import localVarRequest from 'request';
export * from './address';
export * from './affiliation';
export * from './affiliationType';
export * from './affiliationWrite';
export * from './affiliationWritePatch';
export * from './consent';
export * from './consentPurpose';
export * from './consentWrite';
export * from './consentWritePatch';
export * from './country';
export * from './countryWrite';
export * from './countryWritePatch';
export * from './errorCode';
export * from './errorData';
export * from './errorDetails';
export * from './gender';
export * from './maritalStatus';
export * from './metadata';
export * from './nationalId';
export * from './org';
export * from './orgActiveStatus';
export * from './orgType';
export * from './orgWrite';
export * from './orgWritePatch';
export * from './person';
export * from './personRelation';
export * from './personRelationType';
export * from './personWrite';
export * from './personWritePatch';
export * from './preferences';
export * from './preferencesPatch';
export * from './relation';
export * from './relationType';
export * from './relationWrite';
export * from './relationWritePatch';
export * from './role';
export * from './roleAssignment';
export * from './roleAssignmentWrite';
export * from './roleAssignmentWritePatch';
export * from './roleScope';
export * from './roleWrite';
export * from './searchVisibility';
export * from './visibilityPreferences';
export * from './visibilityPreferencesPatch';
export * from './wrappedAffiliation';
export * from './wrappedConsent';
export * from './wrappedCountry';
export * from './wrappedOrg';
export * from './wrappedPerson';
export * from './wrappedRelation';
export * from './wrappedRole';
export * from './wrappedRoleAssignment';
export * from './wrappedWithMetaArrayAffiliation';
export * from './wrappedWithMetaArrayConsent';
export * from './wrappedWithMetaArrayCountry';
export * from './wrappedWithMetaArrayOrg';
export * from './wrappedWithMetaArrayPerson';
export * from './wrappedWithMetaArrayRelation';
export * from './wrappedWithMetaArrayRole';
export * from './wrappedWithMetaArrayRoleAssignment';
import * as fs from 'fs';
export interface RequestDetailedFile {
    value: Buffer;
    options?: {
        filename?: string;
        contentType?: string;
    };
}
export type RequestFile = string | Buffer | fs.ReadStream | RequestDetailedFile;
export declare class ObjectSerializer {
    static findCorrectType(data: any, expectedType: string): any;
    static serialize(data: any, type: string): any;
    static deserialize(data: any, type: string): any;
}
export interface Authentication {
    applyToRequest(requestOptions: localVarRequest.Options): Promise<void> | void;
}
export declare class HttpBasicAuth implements Authentication {
    username: string;
    password: string;
    applyToRequest(requestOptions: localVarRequest.Options): void;
}
export declare class HttpBearerAuth implements Authentication {
    accessToken: string | (() => string);
    applyToRequest(requestOptions: localVarRequest.Options): void;
}
export declare class ApiKeyAuth implements Authentication {
    private location;
    private paramName;
    apiKey: string;
    constructor(location: string, paramName: string);
    applyToRequest(requestOptions: localVarRequest.Options): void;
}
export declare class OAuth implements Authentication {
    accessToken: string;
    applyToRequest(requestOptions: localVarRequest.Options): void;
}
export declare class VoidAuth implements Authentication {
    username: string;
    password: string;
    applyToRequest(_: localVarRequest.Options): void;
}
export type Interceptor = (requestOptions: localVarRequest.Options) => (Promise<void> | void);
