import { ObjectSerializer } from "./models";
export class CoreApiError extends Error {
    constructor(err, httpResponse) {
        var _a;
        super((_a = err.error) === null || _a === void 0 ? void 0 : _a.message);
        this.details = err === null || err === void 0 ? void 0 : err.error;
        this.httpResponse = httpResponse;
    }
    get isCoreApiError() {
        return true;
    }
    static fromHttpResponse(res) {
        const error = ObjectSerializer.deserialize(res.data, "ErrorData");
        return new CoreApiError(error, res);
    }
}
