export function serializeFindQueryParams(p) {
    const params = new URLSearchParams();
    if (p.limit)
        params.append("limit", p.limit.toString());
    if (p.offset)
        params.append("offset", p.offset.toString());
    if (p.page)
        params.append("page", p.page.toString());
    if (p.filter)
        params.append("filter", JSON.stringify(p.filter));
    if (p.fields)
        params.append("fields", p.fields.join(","));
    if (p.sort)
        params.append("sort", serializeSort(p.sort));
    return params;
}
function serializeSort(sorts) {
    return sorts.map(s => s.direction === 'descending' ? '-' : '' + s.path).join(",");
}
export function serializeGetQueryParams(p) {
    const params = new URLSearchParams();
    if (p.fields)
        params.append("fields", p.fields.join(","));
    return params;
}
